using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

namespace Example_5_2
{
  public partial class frmAuthors : Form
  {
    public frmAuthors()
    {
      InitializeComponent();
    }

    OleDbConnection booksConnection;
    OleDbCommand authorsCommand;
    OleDbDataAdapter authorsAdapter;
    DataTable authorsTable;
    CurrencyManager authorsManager;

    private void frmAuthors_Load(object sender, EventArgs e)
    {
      // connect to books database
      booksConnection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source = c:\\VCS2005DB\\Working\\books.mdb");
      booksConnection.Open();
      // establish command object
      authorsCommand = new OleDbCommand("Select * from Authors ORDER BY Author", booksConnection);
      // establish data adapter/data table
      authorsAdapter = new OleDbDataAdapter();
      authorsAdapter.SelectCommand = authorsCommand;
      authorsTable = new DataTable();
      authorsAdapter.Fill(authorsTable);
      // bind controls to data table
      txtAuthorID.DataBindings.Add("Text", authorsTable, "Au_ID");
      txtAuthorName.DataBindings.Add("Text", authorsTable, "Author");
      txtYearBorn.DataBindings.Add("Text", authorsTable, "Year_Born");
      // establish currency manager
      authorsManager = (CurrencyManager) this.BindingContext[authorsTable];
    }

    private void frmAuthors_FormClosing(object sender, FormClosingEventArgs e)
    {
      // close the connection
      booksConnection.Close();
      // dispose of the objects
      booksConnection.Dispose();
      authorsCommand.Dispose();
      authorsAdapter.Dispose();
      authorsTable.Dispose();
    }

    private void btnPrevious_Click(object sender, EventArgs e)
    {
      authorsManager.Position--;
    }

    private void btnNext_Click(object sender, EventArgs e)
    {
      authorsManager.Position++;
    }
  }
}